#pragma once
#include "coroutine.hpp"
#include "io_thread.hpp"
#include "net_address.hpp"
#include <cstdint>
// #include "reactor.hpp"

namespace tinyrpc {
    class TcpAcceptor{
    public:
        TcpAcceptor(const NetAddress& netAddr);
        void init();
        int accept();
    private:
        int m_listenfd{-1};
        NetAddress m_bindNetAddr;
    };

    class TcpServer{

    public:
        TcpServer();
        TcpServer(const NetAddress& addr);
        TcpServer(const std::string& ip, uint16_t port);
        void start();
    private:
        void mainAcceptCorFun();
    private:

        // Reactor* m_reactor{nullptr};
        Coroutine m_accept_cor;
        TcpAcceptor m_acceptor;
        bool m_stop_accept{false};
        // int m_conn_cnt{0};
        IOThread m_ioThread{};
    };

}